/* (C)opyleft 2001 by Frank DENIS aka Jedi/Sector One <j@42-networks.com> */

#include "eliott.h"

static GHashTable *old_state;
static GHashTable *new_state;
static GHashTable *exploit_files;
static GHashTable *exploit_files_reverse;
static int watch_fd = -1;
static const gchar *directory = DEFAULT_DIRECTORY;
static const gchar *hardlink_exploit_target;
static gboolean directory_malloc = FALSE;
static gboolean hardlink_exploit = FALSE;
static off_t target_original_size = (off_t) 0;

static gboolean freeStateEntry(gpointer key, gpointer value, 
			       gpointer user_data)
{
   ScanMetadata *scan_metadata;
   (void) user_data;
      
   g_assert((scan_metadata = value) != NULL);
   g_free(scan_metadata);
   g_assert(key != NULL);
   g_free(key);
   
   return TRUE;
}

static gboolean freeExploitEntry(gpointer key, gpointer value, 
				 gpointer user_data)
{
   (void) user_data;
   
   g_assert(value != NULL);
   g_free(value);
   g_assert(key != NULL);
   g_print("> " _("Unlinking") " [%s]\n", (gchar *) key);
   unlink(key);   
   g_free(key);
   
   return TRUE;
}

static void ptrMetadataArrayFree(GPtrArray * const ptr_array)
{
   register guint z;
   Metadata *md;
   
   g_assert(ptr_array != NULL);
   z = ptr_array->len;
   while (z != 0U) {
      z--;
      md = (Metadata *) g_ptr_array_index(ptr_array, z);
      if (md != NULL) {	 
	 g_free(md->file_name);
	 md->file_name = NULL;
	 g_free(md);	 
	 g_ptr_array_index(ptr_array, z) = NULL;
      }
   }
   g_ptr_array_free(ptr_array, TRUE);
}

static void findDeleted(gpointer key, gpointer value, gpointer user_data)
{
   GPtrArray *deleted_files;
   Metadata *md;
   ScanMetadata *scan_metadata;
   
   g_assert((deleted_files = user_data) != NULL);
   if (g_hash_table_lookup(new_state, key) == NULL) {
      if (hardlink_exploit != FALSE) {
	 if (g_hash_table_lookup(exploit_files, key) != NULL ||
	     g_hash_table_lookup(exploit_files_reverse, key) != NULL) {
	    return;
	 }
      }
      md = g_new(Metadata, 1);
      md->file_name = g_strdup(key);
      g_assert((scan_metadata = value) != NULL);
      g_assert(scan_metadata->has_stat != FALSE);
      md->stat = scan_metadata->stat;
      g_ptr_array_add(deleted_files, md);
   }
}

static const gchar *formatDate(void)
{
   static char timebuf[42];   
   time_t now;
   
   time(&now);
   strftime(timebuf, sizeof timebuf, "[%X] - ", localtime(&now));
   return timebuf;
}

static void processNewFiles(GPtrArray *new_files)
{
   register guint z;
   Metadata *md;
   const gchar *date;
   gint file_type;
   mode_t mode;
   
   g_assert(new_files != NULL);
   date = formatDate();
   z = new_files->len;
   while (z != 0U) {
      z--;
      md = (Metadata *) g_ptr_array_index(new_files, z);      
      if (md != NULL) {	 
	 mode = md->stat.st_mode;
	 if (S_ISSOCK(mode)) {
	    file_type = 's';
	 } else if (S_ISLNK(mode)) {
	    file_type = 'l';
	 } else if (S_ISREG(mode)) {
	    file_type = 'f';
	 } else if (S_ISBLK(mode)) {
	    file_type = 'b';
	 } else if (S_ISDIR(mode)) {
	    file_type = 'd';
	 } else if (S_ISCHR(mode)) {
	    file_type = 'c';
	 } else if (S_ISFIFO(mode)) {
	    file_type = 'p';
	 } else {
	    file_type = '?';
	 }
	 g_print("%s" _("New file :") " [%s] (%lu,%lu) (%c %o)\n", 
		 date, md->file_name, 
		 (unsigned long) md->stat.st_uid,
		 (unsigned long) md->stat.st_gid,
		 file_type, (unsigned int) mode & ~S_IFMT);
      }
   }   
}

static void processDeletedFiles(GPtrArray *deleted_files)
{
   register guint z;
   Metadata *md;
   const gchar *date;
   
   g_assert(deleted_files != NULL);
   date = formatDate();
   z = deleted_files->len;
   while (z != 0U) {
      z--;
      md = (Metadata *) g_ptr_array_index(deleted_files, z);
      if (md != NULL) {
	 g_print("%s" _("Deleted file :") " [%s]\n", date, md->file_name);
      }
      if (hardlink_exploit != FALSE) {
	 gchar *exploit_file_name;
	 int exploit_fd;
	 
	 if (hardlink_exploit_target == NULL) {
	    exploit_file_name = g_strdup(TMP_PREFIX "XXXXXX");
	    g_return_if_fail((exploit_fd = mkstemp(exploit_file_name)) >= 0);
	    if (geteuid() == (uid_t) 0) {
	       fchown(exploit_fd, md->stat.st_uid, md->stat.st_gid);
	    }
	    fchmod(exploit_fd, md->stat.st_mode);
	    close(exploit_fd);
	 } else {
	    exploit_file_name = (gchar *) hardlink_exploit_target;
	 }
	 g_return_if_fail(link(exploit_file_name, md->file_name) == 0);
	 g_print("%s" _("Added fake link :") " [%s] -> [%s]\n",
		 date, exploit_file_name, md->file_name);
	 g_hash_table_insert(exploit_files, exploit_file_name,
			     g_strdup(md->file_name));
	 g_hash_table_insert(exploit_files_reverse, g_strdup(md->file_name),
			     g_strdup(exploit_file_name));
      }      
   }      
}

static void restatExploitFilesTest(gpointer key, gpointer value, 
				   gpointer user_data)
{
   struct stat st;
   GSList **to_remove;
   const gchar *date;
   
   g_assert((to_remove = user_data) != NULL);   
   g_assert(key != NULL);
   g_assert(value != NULL);
   date = formatDate();
   if (lstat(key, &st) != 0) {
      g_print("%s" _("Fake link vanished : [%s] -> [%s]\n"), 
	      date, (gchar *) key, (gchar *) value);
      *to_remove = g_slist_append(*to_remove, key);
      return;
   }
   if (st.st_size != target_original_size) {
      g_print("%s" _("** ALERT, insecure opening ** : [%s] -> [%s]\n"),
	      date, (gchar *) value, (gchar *) key);
      if (hardlink_exploit_target == NULL) {
	 unlink(key);
	 unlink(value);
	 *to_remove = g_slist_append(*to_remove, key);
      } else {
	 target_original_size = st.st_size;
      }
   }
}

static void removeFromExploitFilesList(gpointer key, gpointer user_data)
{
   gpointer value;
   (void) user_data;

   g_assert((value = g_hash_table_lookup(exploit_files, key)) != NULL);
   g_hash_table_remove(exploit_files, key);
   g_hash_table_remove(exploit_files_reverse, value);
}

static void restatExploitFiles(GHashTable *exploit_files)
{
   GSList *to_remove;
   
   to_remove = NULL;
   g_hash_table_foreach(exploit_files, restatExploitFilesTest, &to_remove);
   g_slist_foreach(to_remove, removeFromExploitFilesList, NULL);
   g_slist_free(to_remove);
}

static void handler(int sig, siginfo_t *si, void *data)
{
   GPtrArray *new_files;
   GPtrArray *deleted_files;   
   DIR *dir;
   struct dirent *dir_entry;   
   (void) sig; (void) data;

   if (si != NULL) {
      g_return_if_fail(si->si_fd == watch_fd);
   }
   if (new_state != NULL) {
      if (old_state != NULL) {
	 g_hash_table_foreach_remove(old_state, freeStateEntry, NULL);
	 g_hash_table_destroy(old_state);
      }
      old_state = new_state;
   }
   g_return_if_fail((dir = opendir(directory)) != NULL);
   new_state = g_hash_table_new(g_str_hash, g_str_equal);   
   new_files = g_ptr_array_new();
   while ((dir_entry = readdir(dir)) != NULL) {
      ScanMetadata *scan_metadata;
      ScanMetadata *old_scan_metadata;      
      if (hardlink_exploit != FALSE) {
	 if (g_hash_table_lookup(exploit_files, dir_entry->d_name) != NULL ||
	     g_hash_table_lookup(exploit_files_reverse, dir_entry->d_name) != NULL) {
	    continue;
	 }
      }
      scan_metadata = g_new(ScanMetadata, 1);
      scan_metadata->has_stat = FALSE;      
      g_hash_table_insert(new_state, g_strdup(dir_entry->d_name),
			  scan_metadata);
      if (old_state != NULL) {
	 old_scan_metadata =
	   g_hash_table_lookup(old_state, dir_entry->d_name);
      } else {
	 old_scan_metadata = NULL;
      }
      if (old_state == NULL || old_scan_metadata == NULL) {
	 Metadata *md = g_new(Metadata, 1);
	 
	 g_assert(lstat(dir_entry->d_name, &scan_metadata->stat) == 0);
	 scan_metadata->has_stat = TRUE;	 
	 md->file_name = g_strdup(dir_entry->d_name);
	 md->stat = scan_metadata->stat;
	 scan_metadata->has_stat = TRUE;
	 scan_metadata->stat = md->stat;
	 g_ptr_array_add(new_files, md);
      } else if (old_state != NULL) {	 
	 g_assert(old_scan_metadata != NULL);
	 g_assert(old_scan_metadata->has_stat != FALSE);
	 scan_metadata->has_stat = old_scan_metadata->has_stat;
	 scan_metadata->stat = old_scan_metadata->stat;	 
      }
   }   
   closedir(dir);   
   if (old_state != NULL) {
      deleted_files = g_ptr_array_new();
      g_hash_table_foreach(old_state, findDeleted, deleted_files);
   } else {
      deleted_files = NULL;
   }      
   processNewFiles(new_files);
   if (deleted_files != NULL) {
      processDeletedFiles(deleted_files);
   }
   ptrMetadataArrayFree(new_files);
   if (deleted_files != NULL) {
      ptrMetadataArrayFree(deleted_files);
   }
   if (hardlink_exploit != FALSE) {
      restatExploitFiles(exploit_files);
   }
}

static void cage(void)
{   
   if (geteuid() == (uid_t) 0) {
      g_assert(chroot(directory) == 0);
      directory = G_DIR_SEPARATOR_S ".";
   }
   g_assert(chdir(directory) == 0);   
}

static void setHandler(const gboolean modify)
{
   struct sigaction act;
 
   act.sa_sigaction = handler;
   sigemptyset(&act.sa_mask);
   act.sa_flags = SA_SIGINFO;
   g_assert(sigaction(SIGRTMIN, &act, NULL) == 0);
   g_assert((watch_fd = open(directory, O_RDONLY)) >= 0);
   fcntl(watch_fd, F_SETSIG, SIGRTMIN);
   if (modify == FALSE) {
      fcntl(watch_fd, F_NOTIFY,
	    DN_CREATE|DN_DELETE|DN_RENAME|DN_MULTISHOT);
   } else {
      fcntl(watch_fd, F_NOTIFY, 
	    DN_MODIFY|DN_CREATE|DN_DELETE|DN_RENAME|DN_MULTISHOT);
   }
}

static void removeHandler(void)
{
   struct sigaction act;
 
   act.sa_sigaction = (void *) SIG_DFL;
   sigemptyset(&act.sa_mask);
   act.sa_flags = SA_SIGINFO;
   g_assert(sigaction(SIGRTMIN, &act, NULL) == 0);
   if (watch_fd >= 0) {
      close(watch_fd);
      watch_fd = -1;
   }
}

static void freeAll(void)
{
   if (old_state != NULL) {
      g_hash_table_foreach_remove(old_state, freeStateEntry, NULL);
      g_hash_table_destroy(old_state);
   }
   if (new_state != NULL) {
      g_hash_table_foreach_remove(new_state, freeStateEntry, NULL);
      g_hash_table_destroy(new_state);
   }
   if (hardlink_exploit != FALSE) {
      if (exploit_files != NULL) {
	 g_hash_table_foreach_remove(exploit_files, freeExploitEntry, NULL);
	 g_hash_table_destroy(exploit_files);      
      }
      if (exploit_files_reverse != NULL) {
	 g_hash_table_foreach_remove(exploit_files_reverse, freeExploitEntry, NULL);
	 g_hash_table_destroy(exploit_files_reverse);      
      }     
   }
   if (directory_malloc != FALSE && directory != NULL) {
      g_free((gpointer) directory);
      directory = NULL;
      directory_malloc = FALSE;
   }
   if (hardlink_exploit_target != NULL) {
      g_free((gpointer) hardlink_exploit_target);
      hardlink_exploit_target = NULL;
   }
   if (watch_fd >= 0) {
      close(watch_fd);
      watch_fd = -1;
   }
}

static void end(void)
{
   removeHandler();
   freeAll();
   g_print("> " _("Bye...\n"));
}

static void sigHandler(int sig)
{
   (void) sig;
   exit(EXIT_SUCCESS);
}

static void setSignals(void)
{
   signal(SIGHUP, sigHandler);
   signal(SIGINT, sigHandler);   
   signal(SIGQUIT, sigHandler);
   signal(SIGKILL, sigHandler);
   signal(SIGTERM, sigHandler);      
}

static void showUsage(const char *prg)
{
   const gchar *prgname;
   
   if ((prgname = g_get_prgname()) == NULL || prgname[0] == 0) {
      prgname = prg;
   }
   g_print(_("Usage : %s [OPTION]...\n\n"
	     "-d, --directory=DIRECTORY   Target directory [%s]\n"
	     "-h, --help                  Show help\n"
	     "-l, --link [=target]        Attempt hard links exploits\n\n"),
	   prgname, DEFAULT_DIRECTORY);
}

static void getTargetSize(const gchar * const file)
{
   struct stat st;
   
   if (lstat(file, &st) != 0) {
      g_error(_("Unable to stat [%s]\n"), file);
      g_assert_not_reached();         
   }
   target_original_size = st.st_size;
}

static void parseOptions(int opt_n, char *opt_l[])
{
   int c;
   
   for (;;) {
      int option_index = 0;
      static struct option long_options[] = {
	   { "help", 0, NULL, 'h' },	 
	   { "link", 2, NULL, 'l' },
	   { "directory", 1, NULL, 'd' },
	   { "version", 0, NULL, 'v' },
	   { NULL, 0, NULL, 0 }
      };
      
      c = getopt_long(opt_n, opt_l, "hld:v", long_options, &option_index);
      if (c == -1) {
	 break;
      }
      switch (c) {
       case 'h' :
	 showUsage(opt_l[0]);
	 exit(EXIT_SUCCESS);
       case 'v' :
	 g_print(_("This is") " " PACKAGE ", " _("version ") VERSION ".\n"
		 _("Compiled on") " " __DATE__ ", " __TIME__ ".\n"
		 _("Please report bugs to") " " MAINTAINER " .\n\n");
	 exit(EXIT_SUCCESS);
       case 'l' :
	 hardlink_exploit = TRUE;
	 if (optarg != NULL) {
	    getTargetSize(optarg);	    
	    hardlink_exploit_target = g_strdup(optarg);
	 }
	 break;
       case 'd' :
	 if (*optarg == 0) {
	    directory = ".";
	 } else {
	    directory = g_strdup(optarg);
	    directory_malloc = TRUE;
	 }
	 break;
       case '?' :
	 exit(EXIT_FAILURE);
       default :
	 g_warning(_("getopt returned character %d\n"), c);
      }
   }
}

int main(int opt_n, char *opt_l[])
{
   parseOptions(opt_n, opt_l);
   g_atexit(end);
   setSignals();
   cage();
   if (hardlink_exploit != FALSE) {
      exploit_files = g_hash_table_new(g_str_hash, g_str_equal);
      exploit_files_reverse = g_hash_table_new(g_str_hash, g_str_equal);      
   }
   handler(SIGRTMIN, NULL, NULL);
   setHandler(hardlink_exploit);
   for (;;) {
      pause();
   }
   g_assert_not_reached();   
   
   return 0;
}
